"use strict";

require("core-js/modules/es6.function.name");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.array.find");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.for-each");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.array.some");

var _chokidar = _interopRequireDefault(require("chokidar"));

var _package = require("../package.json");

var _utils = _interopRequireDefault(require("./utils"));

var _writeFiles = _interopRequireDefault(require("./writeFiles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @example
 * new FlowFiles()
 */
var FlowFiles = function FlowFiles() {
  var _this = this;

  _classCallCheck(this, FlowFiles);

  _defineProperty(this, "store", []);

  _defineProperty(this, "watcher", null);

  _defineProperty(this, "add", function (file) {
    _this.store.push(file);

    if (_utils.default.options.watch) _this.openWatcher();
  });

  _defineProperty(this, "fileExist", function (srcPath) {
    return _this.store.some(function (flowFile) {
      return flowFile.srcPath === srcPath;
    });
  });

  _defineProperty(this, "openWatcher", function () {
    var _this$watcher;

    /* eslint-disable flowtype/no-unused-expressions */
    // $FlowFixMe flow not yet supporte
    (_this$watcher = _this.watcher) === null || _this$watcher === void 0 ? void 0 : _this$watcher.close();
    /* eslint-enable flowtype/no-unused-expressions */

    _this.watcher = _chokidar.default.watch(_this.store.map(function (_ref) {
      var filePath = _ref.filePath;
      return filePath;
    }), {
      ignoreInitial: true
    });
    ['add', 'change'].forEach(function (type) {
      var _this$watcher2;

      /* eslint-disable flowtype/no-unused-expressions */
      // $FlowFixMe flow not yet support
      (_this$watcher2 = _this.watcher) === null || _this$watcher2 === void 0 ? void 0 : _this$watcher2.on(type, function (modifyFilePath) {
        /* eslint-enable flowtype/no-unused-expressions */
        var newFile = _this.store.find(function (_ref2) {
          var filePath = _ref2.filePath;
          return modifyFilePath === filePath;
        });

        if (!newFile) return;
        if (!newFile.babelConfig) throw new Error("".concat(_package.name, " Error: not find ").concat(newFile.srcPath, " babel config"));

        _writeFiles.default.add(newFile);
      });
    });
  });
};

var _default = new FlowFiles();

exports.default = _default;
module.exports = exports.default;