"use strict";

require("core-js/modules/es6.function.name");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.array.index-of");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.array.is-array");

require("core-js/modules/es6.array.reduce");

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.regexp.replace");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.for-each");

var _path = _interopRequireDefault(require("path"));

var _options = _interopRequireDefault(require("@babel/cli/lib/babel/options"));

var _package = require("../package.json");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @example
 * new Utils()
 */
var Utils = function Utils() {
  var _this = this;

  _classCallCheck(this, Utils);

  _defineProperty(this, "initialized", false);

  _defineProperty(this, "initialOptions", {
    verbose: false,
    watch: false
  });

  _defineProperty(this, "options", _objectSpread({}, this.initialOptions, {
    src: ['src'],
    outDir: 'lib'
  }));

  _defineProperty(this, "initializeOptions", function (options) {
    if (_this.initialized) return;
    Object.keys(options).forEach(function (key) {
      _this.initialOptions[key] = options[key];
    });

    try {
      var _parseArgv = (0, _options.default)(process.argv),
          _parseArgv$cliOptions = _parseArgv.cliOptions,
          verbose = _parseArgv$cliOptions.verbose,
          filenames = _parseArgv$cliOptions.filenames,
          outFile = _parseArgv$cliOptions.outFile,
          outDir = _parseArgv$cliOptions.outDir,
          watch = _parseArgv$cliOptions.watch; // $FlowFixMe flow not yet support


      _this.initialOptions.src = filenames === null || filenames === void 0 ? void 0 : filenames.map(function (filename) {
        if (outFile) return _path.default.dirname(filename).replace(/^\.\//, '');
        return filename.replace(/^\.\//, '');
      });
      _this.initialOptions.outDir = outFile ? _path.default.dirname(outFile) : outDir;
      _this.initialOptions.verbose = Boolean(verbose);
      _this.initialOptions.watch = Boolean(watch);
      _this.initialized = true;
      if (!_this.initialOptions.src || !_this.initialOptions.outDir) throw new Error('initialized error');
    } catch (e) {
      if (e.message !== 'initialized error') throw new Error("".concat(_package.name, " ").concat(e));
      throw new Error("".concat(_package.name, " only can be used with @babel/cli: Can not find `src` or `outDir`"));
    }
  });

  _defineProperty(this, "manipulateOptions", function (_ref) {
    var plugins = _ref.plugins;

    var _plugins$filter = plugins.filter(function (_ref2) {
      var manipulateOptions = _ref2.manipulateOptions;
      return manipulateOptions === _this.manipulateOptions;
    }),
        _plugins$filter2 = _slicedToArray(_plugins$filter, 1),
        options = _plugins$filter2[0].options;

    var _this$initialOptions = _this.initialOptions,
        src = _this$initialOptions.src,
        outDir = _this$initialOptions.outDir,
        verbose = _this$initialOptions.verbose,
        watch = _this$initialOptions.watch,
        initialOptions = _objectWithoutProperties(_this$initialOptions, ["src", "outDir", "verbose", "watch"]);

    _this.options = _objectSpread({}, initialOptions, options, {
      src: src,
      outDir: outDir,
      verbose: verbose,
      watch: watch
    });
  });

  _defineProperty(this, "getFilePaths", function (filePath, cwd) {
    var _this$options = _this.options,
        src = _this$options.src,
        outDir = _this$options.outDir;
    var srcPath = filePath.replace("".concat(cwd, "/"), '');
    var relativePath = src.reduce(function (result, srcDir) {
      return result.replace(srcDir, '');
    }, srcPath);

    var destPath = _path.default.join(outDir, relativePath).replace(/\.js$/, '.js.flow');

    return {
      srcPath: srcPath,
      destPath: destPath
    };
  });
};

var _default = new Utils();

exports.default = _default;
module.exports = exports.default;